#include <stdio.h>
#include <malloc.h>
#include "zlib.h"

int main(int argc, char *argv[] )
{
	FILE *f;
	char *unc_data;
	int unc_len;
	char *dest_data;
	int dest_len;

	if ( argc != 3 )
	{
		printf( "Usage: <input> <output>\n" );
		return 1;
	}

	// Read the source
	f = fopen( argv[ 1 ], "rb" );
	if ( f == NULL )
	{
		printf( "Input file '%s' not found!\n", argv[ 1 ] );
		return 1;
	}
	fseek( f, 0, SEEK_END );
	unc_len = ftell( f );
	fseek( f, 0, SEEK_SET );
	unc_data = (char *) malloc( unc_len + 1 );
	if ( fread( unc_data, 1, unc_len, f ) != unc_len )
	{
		printf( "Error reading from input file!\n" );
		return 1;
	}
	fclose( f );

	// Compress
	dest_len = 10 + unc_len * 2;
	dest_data = (char *) malloc( dest_len );
	if ( compress2( dest_data, &dest_len, unc_data, unc_len, Z_BEST_COMPRESSION ) != Z_OK )
	{
		printf( "Compress error!\n" );
		return 1;
	}

	printf( "Compressed %d -> %d\n", unc_len, dest_len );

	// Uncompress
	if ( uncompress( unc_data, &unc_len, dest_data, dest_len ) != Z_OK )
	{
		printf( "Uncompress error!\n" );
		return 1;
	}

	printf( "Uncompressed %d -> %d\n", dest_len, unc_len );

	// Write
	f = fopen( argv[ 2 ], "wb" );
	if ( f == NULL )
	{
		printf( "Unable to open the output file!\n" );
		return 1;
	}
	fwrite( dest_data, 1, dest_len, f );
	fclose( f );

	return 0;
}
